#include<iostream.h>
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include "structur.h"

int menu();
void Add(FILE *fptr),init(),deinit(),disp(FILE *fptr),Mod(FILE *fptr);
void disprec(struct MOT rec),WriteMOT(),Sort(),TrimString(char *);
int Check(char *,BYTE type,int op_code);
void Delete(),Types();
FILE *pMOT;

void main()
{
	int ret;
	init();
	while(1)
	{
		ret=menu();
		switch (ret)
		{
			case '1':
				Add(pMOT);
				break;
			case '2':
				printf("\n\n\t\tThe Machine op table");
				disp(pMOT);
				break;
			case '3':
				printf("\nWriting out the MOT header file...\t");
				WriteMOT();
				printf("done.");
				break;
			case '4':
				Delete();
				break;
			case '5':
				printf("\nSorting...\t");
				Sort();
				printf("done.");
				disp(pMOT);
				break;
			case '6':
				Mod(pMOT);
				break;
			case '0':
				deinit();
				return;
			default:
				printf("\nInvalid choice!");
		}
		printf("\nPress any key to proceed...");
		getch();
	}

}

int menu()
{
	char ret;
	clrscr();
	printf("\n\t\tMachine OP table creation utility");
	printf("\n1. Add to MOT\n2. Display MOT\n3. Write MOT.h\n4. Delete Mnemonic\n5. Sort\n6. Modify\n0. Exit");
	printf("\nEnter your choice : ");
	ret=getche();
	return ret;
}

void init()
{
	pMOT=fopen("MOT.dat","r+b");

	if(pMOT==NULL)
		pMOT=fopen("MOT.dat","w+b");

	if(pMOT==NULL)
	{
		printf("\nUnable to open MOT.dat");
		exit(0);
	}
}
void deinit()
{
	fclose(pMOT);
}

void Add(FILE *fptr)
{
  int temp,valid;
  struct MOT rec;
  char ans;
  fseek(fptr,0,SEEK_END);
  while(1)
  {
	printf("\nMnemonic op code  : ");
	gets(rec.mne_op);
	fflush(stdin);
	TrimString(rec.mne_op);
	valid=0;
	while(!valid)
	{
		valid=1;
		Types();
		printf("\nType		: ");
		scanf("%d",&temp);
		fflush(stdin);
		if(temp <0 || temp>9)
		{
			printf("\nInavlid type format!");
			printf("\nPlease retry!");
			valid=0;
		}
	}
	rec.type=temp;
	printf("\nBinary op code (in hex) 	: 0x");
	scanf("%x",&rec.op_code);
	fflush(stdin);

	printf("\nChecking for uniqueness...");
	if(!Check(rec.mne_op,rec.type,rec.op_code))
	{
		printf("Mnemonic op <%s> already exists!",rec.mne_op);

		printf("\nAre you sure you want another record? [Y/N] ");
		ans=getche();
		fflush(stdin);
		if (ans!='Y' && ans !='y')
			break;
	}
	else
		printf("\tMnemonic unique!");
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nWide bit [1/0] : ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.w=1;
		else if(ans=='0')
			rec.w=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nDirection bit [1/0] : ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.d=1;
		else if(ans=='0')
			rec.d=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//S bit
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nS bit [1/0] : ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.s=1;
		else if(ans=='0')
			rec.s=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}

	//V bit
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nV bit [1/0] : ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.v=1;
		else if(ans=='0')
			rec.v=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//Z bit
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nZ bit [1/0] : ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.z=1;
		else if(ans=='0')
			rec.z=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	rec.Reg_op=0;
	rec.Reg_operand=0;
	rec.ext_op_code=0;

	//Register in op_code
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nRegister operand in op code bit    :");
		printf("\n(0 if not present)[position 0-7]    ");
		gotoxy(wherex(),wherey()-1);
		scanf("%d",&temp);
		fflush(stdin);
		if(temp >=0 && temp <=7)
			rec.Reg_op=temp;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//Register operand between MOD and RM bits
	valid=0;
	while(!valid && (rec.type == 7 || rec.type==8))
	{
		valid=1;
		printf("\nRegister operand between MOD and RM bits : ");
		printf("\n- if not present                           ");
		gotoxy(wherex(),wherey()-1);
		ans=getche();
		fflush(stdin);
		if(ans >='0' && ans <= '9')
			temp=ans-'0';
		else
			temp=8;
		if( ans == '-')
		{
			rec.Reg_operand=0;
			rec.Reg_operand_valid=0;
		}
		else if( temp >=0 && temp < 8)
		{
			rec.Reg_operand=temp;
			rec.Reg_operand_valid=1;
		}
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//Long op code
	if(rec.type == 1)
	{
		printf("\nLong OP code [ 2nd byte ] : 0x");
		scanf("%X",&temp);
		rec.ext_op_code=temp;
		fflush(stdin);
	}
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nSegment Register [1/0] : ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.SegmentRegister=1;
		else if(ans=='0')
			rec.SegmentRegister=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nAccumulator bit [1/0]	: ");
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.Accumulator=1;
		else if(ans=='0')
			rec.Accumulator=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
//**********FarCall
	if(rec.type==7)
	{
		valid=0;
		while(!valid)
		{
			valid=1;
			printf("\nFar Call [1/0] : ");
			ans=getche();
			fflush(stdin);
			if(ans=='1')
				rec.FarCall=1;
			else if(ans=='0')
				rec.FarCall=0;
			else
			{
				printf("\nInvalid entry.\nPlease retry!");
				valid=0;
			}
		}
	}
	else
		rec.FarCall=0;
//***************
	printf("\n<Mnemonic op code> <Binary op code> <Type>   w d s v z Reg1 Reg2 Seg AX  LOp Far");
	disprec(rec);
	printf("\nIs record correct? [Y/N] ");
	ans=getche();
	fflush(stdin);
	if (ans!='Y' && ans !='y')
		printf("\nRecord not written.");
	else
	{
		fseek(fptr,0,SEEK_END);
		fwrite(&rec,sizeof(rec),1,fptr);
		printf("\nRecord written");
	}
	printf("\nDo you want to continue? [Y/N] ");
	ans=getche();
	fflush(stdin);
	if (ans!='Y' && ans !='y')
		return;
  }

}

void disp(FILE *fptr)
{
	long count=0;
	struct MOT rec;
	fseek(fptr,0,SEEK_SET);
	printf("\n<Mnemonic op code> <Binary op code> <Type>   w d s v z Reg1 Reg2 Seg AX  LOp Far");
	while(fread(&rec,sizeof(rec),1,fptr))
	{
		count++;
		if(count%24 == 0)
		{
			printf("\nPress any key to continue...");
			getch();
			fflush(stdin);
		}
		disprec(rec);
	}
	printf("\nTotal records %d",count);
}

void disprec(struct MOT rec)
{
	printf("\n\t%s\t\t0x%X\t\t%d",rec.mne_op,rec.op_code,rec.type);
	printf("    %d %d %d %d %d",rec.w, rec.d, rec.s, rec.v, rec.z);
	printf("  %d    ",rec.Reg_op);
	if(rec.Reg_operand_valid)
		printf("%d",rec.Reg_operand);
	else
		printf("-");
	printf("   %d   %d   0x%X",rec.SegmentRegister, rec.Accumulator, rec.ext_op_code);
	printf(" %d",rec.FarCall);
}

void WriteMOT()
{
	struct MOT rec;
	FILE *fphdr;
	Sort();
	fphdr=fopen("MOT.h","w");
	fseek(pMOT,0,0);
	fprintf(fphdr,"MOT mot[]=\n{");
	//print table
	while(fread(&rec,sizeof(rec),1,pMOT))
	{
		fprintf(fphdr,"\n\t\"%s\",%d,%d,%d,",rec.mne_op,rec.op_code,rec.ext_op_code,rec.type);
		fprintf(fphdr,"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,",rec.Reg_op,rec.Reg_operand,rec.Reg_operand_valid,
				rec.w,rec.d,rec.s,rec.v,rec.z,rec.Accumulator,rec.SegmentRegister,rec.FarCall);
	}
	fprintf(fphdr,"\n};");
	fclose(fphdr);
}

int Check(char *op, BYTE type,int op_code)
{
	struct MOT rec;
	fseek(pMOT,0,SEEK_SET);
	while(fread(&rec,sizeof(rec),1,pMOT))
	{
		if(strcmp(rec.mne_op,op)==0 && rec.type== type && rec.op_code==op_code)
			return 0;
	}
	return 1;
}

void TrimString(char *String)
{
	char str[7];
	int i,j;
	strcpy(str,String);
	for( i=0 ; str[i] == ' ' || str[i] == '\t' ; i++);
	for( j=0 ; str[i] != ' ' && str[i] != '\t' && str[i] != 0; i++ , j++)
		String[j]=str[i];
	String[j]=0;
	strupr(String);
}

void Delete()
{
	int del=0;
	MOT rec;
	char op[7];
	int type;
	FILE *pTemp;

	printf("\n\nEnter the mnemonic to be deleted : ");
	gets(op);
	TrimString(op);
	Types();
	printf("\nType	: ");
	scanf("%d",&type);
	fflush(stdin);

	pTemp=fopen("Temp.dat","w+b");

	fseek(pMOT,0,SEEK_SET);
	while(fread(&rec,sizeof(rec),1,pMOT))
	{
		if(strcmp(rec.mne_op,op)!=0 || rec.type!=type)
			fwrite(&rec,sizeof(rec),1,pTemp);
		else
			del++;
	}
	fseek(pTemp,0,SEEK_SET);
	fclose(pMOT);
	pMOT=fopen("MOT.dat","w+b");
	while(fread(&rec,sizeof(rec),1,pTemp))
	{
		fwrite(&rec,sizeof(rec),1,pMOT);
	}
	fclose(pMOT);
	fclose(pTemp);
	init();
	printf("\n%d records deleted",del);

}

void Sort()
{
	FILE *pTemp;
	MOT rec1,rec2;
	int count,idx,result;

	pTemp=fopen("Temp.dat","w+b");

	while(1)
	{
		fseek(pMOT,0,SEEK_SET);
		count=0;
		while(fread(&rec1,sizeof(rec1),1,pMOT))
		{
			count++;
			if(rec1.mne_op[0]!=0)
				break;
		}
		if(rec1.mne_op[0]==0 || count == 0)
			break;
		idx=count;
		while(fread(&rec2,sizeof(MOT),1,pMOT))
		{
			count++;
			result=strcmp( rec1.mne_op, rec2.mne_op );
			if ( rec2.mne_op[0]!=0 && ( result > 0  || (result ==0 && rec2.type< rec1.type)))
			{
				idx=count;
				rec1=rec2;
			}
		}
		fwrite(&rec1,sizeof(rec1),1,pTemp);
		fseek(pMOT, ( (idx-1) * sizeof(MOT) ) ,SEEK_SET);
		rec1.mne_op[0]=0;
		fwrite(&rec1,sizeof(rec1),1,pMOT);
	}
	//copying back
	fseek(pTemp,0,SEEK_SET);
	fclose(pMOT);
	pMOT=fopen("MOT.dat","w+b");
	while(fread(&rec1,sizeof(rec1),1,pTemp))
	{
		fwrite(&rec1,sizeof(rec1),1,pMOT);
	}
	fclose(pMOT);
	fclose(pTemp);
	init();
}

void Types()
{
	printf("\n0. No operand [0 bytes]");
	printf("\n1. Long opcode no operand [1 byte]");
	printf("\n2. Immediate data [ 1 orr 2 bytes ]");
	printf("\n3. Type / Port [ 1 byte]");
	printf("\n4. Displacement / Direct address [ 2 bytes ]");
	printf("\n5. Displacement [ 1 byte ]");
	printf("\n6. Offset and segment base [ 4 bytes ]");
	printf("\n7. Mod/RM [ 1-3 bytes ]");
	printf("\n8. Mod/RM with immediate data [2 - 5 bytes ] ");

}

void Mod(FILE *fptr)
{
  int temp,valid, found;
  struct MOT rec,rec1;
  char ans;
  while(1)
  {
	printf("\nModifying");
	printf("\nMnemonic op code  : ");
	gets(rec.mne_op);
	fflush(stdin);
	TrimString(rec.mne_op);
	valid=0;
	while(!valid)
	{
		valid=1;
		Types();
		printf("\nType		: ");
		scanf("%d",&temp);
		fflush(stdin);
		if(temp <0 || temp>9)
		{
			printf("\nInavlid type format!");
			printf("\nPlease retry!");
			valid=0;
		}
	}
	rec.type=temp;
	printf("\nBinary op code (in hex) 	: 0x");
	scanf("%x",&rec.op_code);
	fflush(stdin);

	printf("\nRetrieving record...");
	fseek(fptr,0,SEEK_SET);
	found=0;
	while(fread(&rec1,sizeof(rec1),1,fptr))
	{
		if(strcmp(rec.mne_op,rec1.mne_op)==0 && rec.type== rec1.type && rec.op_code==rec1.op_code)
		{
			found=1;
			break;
		}
	}

	if(!found)
	{
		printf("\n0 matches found");
		break;
	}
	printf("\nMatch found");
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nWide bit [1/0] : %d :",rec1.w);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.w=1;
		else if(ans=='0')
			rec.w=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nDirection bit [1/0] : %d :", rec1.d);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.d=1;
		else if(ans=='0')
			rec.d=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//S bit
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nS bit [1/0] : %d : ",rec1.s);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.s=1;
		else if(ans=='0')
			rec.s=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}

	//V bit
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nV bit [1/0] : %d: ",rec1.v);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.v=1;
		else if(ans=='0')
			rec.v=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//Z bit
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nZ bit [1/0] :%d: ",rec1.z);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.z=1;
		else if(ans=='0')
			rec.z=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	rec.Reg_op=0;
	rec.Reg_operand=0;
	rec.ext_op_code=0;

	//Register in op_code
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nRegister operand in op code bit    : %d :",rec1.Reg_op);
		printf("\n( 0 if not present )  [ position 0-7 ]   ");
		gotoxy(wherex(),wherey()-1);
		scanf("%d",&temp);
		fflush(stdin);
		if(temp >=0 && temp <=7)
			rec.Reg_op=temp;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//Register operand between MOD and RM bits
	valid=0;
	while(!valid && (rec.type == 7 || rec.type==8))
	{
		valid=1;

		printf("\nRegister operand between MOD and RM bits  : ");
		if(rec.Reg_operand_valid)
			printf("%d :",rec.Reg_operand);
		else
			printf("- :");
		printf("\n- if not present                            ");
		gotoxy(wherex(),wherey()-1);
		ans=getche();
		fflush(stdin);
		if(ans >='0' && ans <= '9')
			temp=ans-'0';
		else
			temp=8;

		if( ans == '-')
		{
			rec.Reg_operand=0;
			rec.Reg_operand_valid=0;
		}
		else if( temp >=0 && temp < 8)
		{
			rec.Reg_operand=temp;
			rec.Reg_operand_valid=1;
		}

		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	//Long op code
	if(rec.type == 1)
	{
		printf("\nLong OP code [ 2nd byte ] : 0x%X : 0x",rec1.ext_op_code);
		scanf("%X",&temp);
		rec.ext_op_code=temp;
		fflush(stdin);
	}
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nSegment Register [1/0] : %d : ",rec1.SegmentRegister);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.SegmentRegister=1;
		else if(ans=='0')
			rec.SegmentRegister=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}
	valid=0;
	while(!valid)
	{
		valid=1;
		printf("\nAccumulator bit [1/0]	: %d :",rec1.Accumulator);
		ans=getche();
		fflush(stdin);
		if(ans=='1')
			rec.Accumulator=1;
		else if(ans=='0')
			rec.Accumulator=0;
		else
		{
			printf("\nInvalid entry.\nPlease retry!");
			valid=0;
		}
	}

//**********FarCall
	if(rec.type==7)
	{
		valid=0;
		while(!valid)
		{
			valid=1;
			printf("\nFar Call [1/0] : ");
			ans=getche();
			fflush(stdin);
			if(ans=='1')
				rec.FarCall=1;
			else if(ans=='0')
				rec.FarCall=0;
			else
			{
				printf("\nInvalid entry.\nPlease retry!");
				valid=0;
			}
		}
	}
	else
		rec.FarCall=0;
//***************

	printf("\n<Mnemonic op code> <Binary op code> <Type> < w d s v z Reg1 Reg2 Seg AX Long op>");
	disprec(rec);
	printf("\nIs record correct? [Y/N] ");
	ans=getche();
	fflush(stdin);
	if (ans!='Y' && ans !='y')
		printf("\nRecord not written.");
	else
	{
		long l=ftell(fptr);
		l = l - sizeof(rec);
		fseek(fptr,l,SEEK_SET);
		l=ftell(fptr);
		fwrite(&rec,sizeof(rec),1,fptr);
		printf("\nRecord written");
	}
	printf("\nDo you want to continue? [Y/N] ");
	ans=getche();
	fflush(stdin);
	if (ans!='Y' && ans !='y')
		return;
  }
}
