//Main program
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include "Assm.h"

void Assemble(char *);

void main(int count, char *args[])
{
	printf("\n\n8086 Assembler, Copyright (C) Manoj Paul Joseph, 2000.");
	if(count==1)
		printf("\nSyntax: 8086 <source file list>");
	else
	{
		for(int i = 1 ; i < count; i++)
		{
			printf("\n\nAssembling    : %s",args[i]);
			Assemble(args[i]);
		}
	}
}

void Assemble(char * file)
{
	int ret = 0;

	CAssemble pro( file );
	if(pro.Pass1())
	{
		ret = pro.Pass2();
	}
	if( pro.Errors + pro.Warnings + ret != 0 )
	{
		printf("\nWarnings      : %d",pro.Warnings);
		printf("\nErrors        : %d",pro.Errors);
	}
}