#include <stdio.h>
#include <conio.h>

#define BYTE unsigned char

struct hdr
{
	BYTE hd;
	int size;
};

void decode(char *);
void main(int count, char *args[])
{
	printf("\n\nObject decoder");
	printf("\nCopyright (C) Manoj Paul Joseph 2000\n");
	if(count==1)
	{
		printf("\nSyntax: objdec <OBJ file>");
	}
	else
		decode(args[1]);
	printf("\nDone");
}

void decode(char * file)
{
	int i, col, col2;
	struct hdr head;
	BYTE data;
	FILE * fp;

	fp = fopen(file,"rb");
	clrscr();
	if (fp == NULL)
	{
		printf("\nInvalid file name");
		return;
	}
	while( fread(&head, sizeof(head), 1, fp) )
	{
		switch(head.hd)
		{
			case 0x80:
				printf("\nTHEADR  : ");
				break;
			case 0x88:
				printf("\nCOMENT  : ");
				break;
			case 0x8A:
				printf("\nMODEND  : ");
				break;
			case 0x8C:
				printf("\nEXTDEF  : ");
				break;
			case 0x8E:
				printf("\nTYPEDEF : ");
				break;
			case 0x90:
				printf("\nPUBDEF  : ");
				break;
			case 0x94:
				printf("\nLINNUM  : ");
				break;
			case 0x96:
				printf("\nLNAMES  : ");
				break;
			case 0x98:
				printf("\nSEGDEF  : ");
				break;
			case 0x9A:
				printf("\nGRPDEF  : ");
				break;
			case 0x9C:
				printf("\nFIXUPP  : ");
				break;
			case 0xA0:
				printf("\nLEDATA  : ");
				break;
			case 0xA2:
				printf("\nLIDATA  : ");
				break;
			case 0xB0:
				printf("\nCOMDEF  : ");
				break;
		}
		printf(" %0.2d",head.size);
		for(i=1, col= 15, col2 = 60; i < head.size; i++, col+=3, col2++)
		{
			if(wherey() >= 25)
			{
				printf("\nPress any key to continue...");
				getch();
				fflush(stdin);
				clrscr();
			}
			if( col>=50 )
			{
				col  = 15;
				col2 = 60;
				gotoxy(col, wherey()+1 );
			}
			fread(&data, sizeof(data), 1, fp);
			gotoxy(col, wherey() );
			printf(" %0.2X",data);
			gotoxy(col2 , wherey() );
			if(data<32)
				printf(".");
			else
				printf("%c",data);
		}
		gotoxy(col, wherey() );
		fread(&data, sizeof(data), 1, fp);
		printf(" [%0.2X]",data);
	}
	fclose(fp);
}