#ifndef CSTRING
#define CSTRING 105
#include <stdio.h>

class CString
{
	private:
		char * string;
		int Count;			//Count of number of bytes allocated
		int Step;

	public:
		CString(int count= 17);
		CString(char * str );
		CString(CString & );
		~CString();
		char const *GetPointer();
		int GetLength();
		int SetAt(int index, char c);
		int SetLength(int len);

		char operator [] (int index);
		CString & operator += (char * str);
		CString& CString::operator += (char c);
		CString & operator += (CString &str);
		CString & operator = (CString & Str);	//Copy constructor
		const CString & operator = (char *);
		void Print();
		void Print(char *Format);
		int Empty();
		int IsEmpty();
		void Trim();
		int ToInteger();
		int IsInteger();
		int ToUpper();
		int Compare(char *);
		int Compare(CString &);
		void CopyTo(char *);
		CString SubString(int Offset);
		int ReadFile(FILE *);
		int WriteFile(FILE *);
		FILE * FileOpen(char * mode);
};
#endif