// Lists of the Symbol and Litral tables
#include <stdio.h>
#include <string.h>
#include "structur.h"
#include "Sym_Lit.h"

CSymLit::CSymLit()
{
	First = NULL;
	Last = NULL;
	StartPublic = NULL;
	count=0;
}

CSymLit::~CSymLit()
{
//	printf("\nCSymLit Destructor");
}

int CSymLit::AddItem(List item)
{
	ListItems *NewItem;
	CString temp;
	temp=item.symbol;
	NewItem = new ListItems;
	if (NewItem == NULL)
	{
		return -1;
	}
	if(GetItem(temp))
		return -2;
	strupr(item.symbol);
	strupr(item.Segment);
	NewItem->Item = item;
	NewItem->Next = NULL;
	if( Last == NULL)
	{
		First = NewItem;
		Last = NewItem;
	}
	else
	{
		Last->Next = NewItem;
		Last = NewItem;
	}
	count++;
	return (count - 1);
}

BOOL CSymLit::MakePublic(CString &Symbol)
{
	struct Pub * NewPub;
	NewPub = new (struct Pub);
	if( NewPub == 0 )
		return 0;
	Symbol.CopyTo(NewPub->Symbol);
	NewPub->Next = StartPublic;
	StartPublic = NewPub;
	return 1;
}

BOOL CSymLit::SetPublics(CString &Sym, int &error)
{
	List *item;
	struct Pub * Temp;
	while( StartPublic )
	{
		Sym = StartPublic->Symbol;
		item = GetItem( Sym );
		if( ! item )
		{
			error = 1;
			return 0;
		}
		if( item->CombineClass =='E')
		{
			error = 2;
			return 0;
		}
		item->CombineClass='P';
		Temp = StartPublic;
		StartPublic = StartPublic->Next;
		delete Temp;
	}
	Sym.Empty();
	return 1;
}

List * CSymLit::GetItem(CString &sym)
{
	for ( ListItems * Temp = First; Temp != NULL; Temp = Temp->Next )
	{
		if(sym.Compare(Temp->Item.symbol)==0)
			return &(Temp->Item);
	}
	return NULL;
}

List* CSymLit::GetAt(int idx)
{
	int i;
	ListItems * Temp;
	if(count > idx && idx>=0)
	{
		for ( i = 0, Temp = First; Temp != NULL; Temp = Temp->Next, i++ )
		{
			if( i == idx )
				return &(Temp->Item);
		}
	}
	return NULL;
}
